%define ruby_sitelib %(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")
%define gemdir %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%define stylingdir /var/www/genome-styling
%define webscriptsdir /var/www/genome-scripts

%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

Name: genome
Summary: Genome Framework
Version: 1.4.1
Release: 1%{?dist}
Group: Applications/System
License: GPLv2
URL: https://fedorahosted.org/genome
Source0: https://fedorahosted.org/releases/g/e/genome/genome-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
Genome Framework

##
## Genome Library Package
##
%package lib
Summary: Library of common Genome tools
Group: Applications/System
Requires: genome
Requires: facter
Requires: rubygems
Requires: rubygem(reststop)
Requires: rubygem(activesupport)
License: GPLv2

%description lib
Common library used by Genome tools

##
## Genome Bootstrap Package
##
%package bootstrap
Summary: Tool for provisioning virtual machines
Group: Applications/System
Requires: rubygems
Requires: rubygem(highline)
Requires: rubygem(reststop)
Requires: rubygem(main)
Requires: genome
Requires: genome-lib
Requires: genome-sync
Requires: wget
Requires: puppet
Requires: git
BuildRequires: rubygems
BuildRequires: rubygem-rake
BuildArch: noarch
Provides: rubygem(%{gemname}) = %{version}
Obsoletes: rubygem-genome-bootstrap < 1.1
Provides: rubygem-genome-bootstrap

%description bootstrap
Tool for bootstrapping the puppet configuration on machine images

##
## Genome Bridge Package
##
%package bridge
Summary: Genome network bridge
License: GPLv2
Group: System Environment/Base
BuildArch: noarch
Requires: genome
Requires(post): chkconfig
Requires(preun): chkconfig

%description bridge
Genome network bridging for kvm

##
## Genome Docs Package
##
#%package docs
#Summary: Genome documentation
#Group: Applications/System
#License: GPLv2
#BuildArch: noarch
#BuildRequires: publican, publican-genome

#%description docs
#Genome publican documentation

##
## Genome DSL Package
##
%package dsl
Summary: Genome Machine Type Domain Specific Language
License: GPLv2+
Group: Applications/System
Requires: rubygems
Requires: genome
BuildRequires: rubygems
BuildArch: noarch
Provides: rubygem(%{gemname}) = %{version}
Obsoletes: rubygem-genome-dsl < 1.1
Provides: rubygem-genome-dsl

%description dsl
Library to support the domain specific language that the
Genome framework uses the define machine types.

##
## Genome Firstboot Package
##
%package firstboot
Summary: Genome bootstrapping service
Group: Applications/System
License: GPLv2
Requires: genome
Requires(post): chkconfig
Requires(preun): chkconfig

%description firstboot
Genome firstboot-like bootstrapping service

##
## Genome Func Package
##
%package func
Summary: Genome Func Applications
Requires: genome
Requires: func >= 0.21-2
Group: Applications/System

%description func
Genome Func Applications to support the cloudmasterd functions

##
## Genome Release Package
##
%package release
Summary: Genome repository configuration
Group: Applications/System
Requires: genome

%description release
This package contains the Genome repository GPG key as well as configuration
for the Yum package manager.

##
## Genome Replace-Self Package
##
%package replace-self
Summary: Genome Replace Self Utility
Group: Applications/System
Requires: genome
Requires: e2fsprogs

%description replace-self
Genome scripts to bring a system to a certain state
to allow a koan --replace-self to be run on the machine
using a default or specified profile.

##
## Genome Repo Package
##
%package repo
Summary: Genome repository
Group: Applications/System
BuildRequires:  git
Requires:       puppet
Requires:       puppet-server
Requires:       cobbler >= 1.1.0
Requires:       yum-utils
Requires:       syslinux
Requires:       gitweb
Requires:       httpd

%if 0%{?fedora} >= 9
Requires:       git-all
%else
Requires:       git
%endif

Requires:       git-daemon
Requires:       genome
Requires:       genome-server
Requires:       genome-sync
Requires:       genome-site
Requires:       genome-docs

%description repo
Barebones Genome repository.  See documentation for quick setup.

##
## Genome ReSpin Package
##
%package respin
Summary: Genome Revisor Configuration Files
Requires: revisor-cli
Group: Applications/System
Requires: genome
BuildRequires: perl

%description respin
Revisor Configuration Files for Genome Spins

##
## Gheghe, gnagna
##
%package -n revisor-genome
Summary: Genome Revisor Configuration Files
Requires: genome-respin
Group: Applications/System

%description -n revisor-genome
Revisor Configuration Files for Genome Spins

##
## Genome Styling Package
##
%package styling
Summary: Genome CSS Styles
Requires: httpd
Requires: genome
Group: Applications/System

%description styling
Genome CSS Styles

##
## Genome Sync Package
##
%package sync
Summary: A tool for synchronizing Genome Repositories
Group: Development/Languages
Requires: rubygems
Requires: rubygem(git) >= 1.0.7.1
Requires: rubygem(main)
Requires: rubygem(highline)
Requires: genome
BuildRequires: rubygems
BuildRequires: rubygem-rake
BuildArch: noarch
Provides: rubygem(%{gemname}) = %{version}
Obsoletes: rubygem-genome-sync < 1.1
Provides: rubygem-genome-sync

%description sync
A tool for synchronizing Genome Repositories

##
## Genome Server Package
##
%package server
Summary: Daemon for Genome machine configuration
Group: Applications/System
Requires: rubygems
Requires: rubygem(camping)
Requires: rubygem(activesupport)
Requires: rubygem(reststop) >= 0.2.1
Requires: genome
Requires: genome-dsl
Requires: genome-lib
Requires: genome-styling
BuildRequires: rubygems
BuildRequires: rubygem-rake
BuildArch: noarch
Provides: rubygem(%{gemname}) = %{version}
Obsoletes: rubygem-genomed < 1.1
Provides: rubygem-genomed

%description server
Genome Appliance daemon for machine configuration

##
## Genome Cloudhost Package
##
%package cloudhost
Summary: Genome library and web application for managing virtual machines on a host
Group: Applications/System
Requires: sqlite
Requires: genome
Requires: genome-lib
Requires: genome-styling
Requires: koan
Requires: python-virtinst
Requires: /usr/bin/virsh
Requires: rubygems
Requires: rubygem(camping)
Requires: rubygem(activesupport)
Requires: rubygem(activerecord)
Requires: rubygem(sqlite3-ruby)
Requires: rubygem(reststop) >= 0.2.1
Requires: genome-styling
Requires(post): chkconfig
BuildRequires: rubygems
BuildArch: noarch
Provides: rubygem(%{gemname}) = %{version}

%description cloudhost
The cloudhost daemon runs by default on port 8108 that is proxy passed by
apache from the root context.  This daemon provides a REST style interface to
both create new machine instances and manage the existing machine instances.
It also provides a view of the free memory on a host.

##
## Genome Cloudhost HTTPD Package
##
%package cloudhost-httpd
Summary: ProxyPass support for the cloudhost
Requires: genome
Requires: httpd
Group: Applications/System
Provides: httpd-cloudhost

%description cloudhost-httpd
In order to abstract the port that the cloudhost runs on,
this RPM enables ProxyPass support from httpd to the cloudhost
daemon running on port 8108.

##
## Genome Cloudhost HTTPD Redirect Package
##
%package cloudhost-httpd-redirect
Summary: Enables redirecting the root context for the cloudhost
Requires: genome
Requires: httpd
Group: Applications/System
Provides: httpd-redirect-cloudhost

%description cloudhost-httpd-redirect
When this RPM is installed, the default context is redirected
to the cloudhost context.

##
## Genome Cloudmasterd Package
##
%package cloudmasterd
Summary: Genome library and web application for managing cloud machines
Group: Applications/System
Requires: sqlite
Requires: genome
Requires: genome-lib
Requires: genome-styling
Requires: koan
Requires: python-virtinst
Requires: /usr/bin/virsh
Requires: rubygems
Requires: rubygem(camping)
Requires: rubygem(activesupport)
Requires: rubygem(activerecord)
Requires: rubygem(sqlite3-ruby)
Requires: rubygem(reststop) >= 0.2.1
Requires: genome-styling
Requires(post): chkconfig
BuildRequires: rubygems
BuildArch: noarch
Provides: rubygem(%{gemname}) = %{version}
Obsoletes: rubygem-cloudmasterd < 1.1
Provides: rubygem-cloudmasterd

%description cloudmasterd
The cloudmasterd daemon runs by default on port 8107 that is proxy passed by
apache from the root context.  This daemon provides a REST style interface to
both create new machine instances and manage the existing machine instances.
It also provides a view of the cloud instances available and the amount of
free memory that is available.  A cloud consists of multiple cloud instances
(e.g. cloud1.example.org, cloud2.example.org) which in turn host multiple
machine instances (e.g. jboss1.example.org, jboss2.example.org).

Func (https://fedorahosted.org/func) is used to aggregate all the information
from the individual cloud instances to store in a sqlite database on the
cloud master.

##
## Genome Cloudmaster HTTPD Package
##
%package cloudmasterd-httpd
Summary: ProxyPass support for the cloudmaster
Requires: genome
Requires: httpd
Group: Applications/System
Obsoletes: httpd-cloudmasterd < 1.1
Provides: httpd-cloudmasterd

%description cloudmasterd-httpd
In order to abstract the port that the cloudmaster runs on,
this RPM enables ProxyPass support from httpd to the cloudmaster
daemon running on port 8107.


##
## Genome Cloudmaster HTTPD Redirect Package
##
%package cloudmasterd-httpd-redirect
Summary: Enables redirecting the root context for the cloudmaster
Requires: genome
Requires: httpd
Group: Applications/System
Obsoletes: httpd-redirect-cloudmasterd < 1.1
Provides: httpd-redirect-cloudmasterd

%description cloudmasterd-httpd-redirect
When this RPM is installed, the default context is redirected
to the cloudmaster context.

##
## Genome Report Package
##
%package report
Summary: Reporting tool for Genome
Group: Applications/System
Requires: sqlite
Requires: facter
Requires: rubygems
Requires: rubygem(reststop) >= 0.2.1
Requires: rubygem(main)
Requires: genome
Requires: genome-lib
BuildRequires: rubygems
BuildRequires: rubygem-rake
BuildArch: noarch
Provides: rubygem-genome-report

%description report
This tool is used in conjunction with the Cloud Master and Cloud Host services.

%prep
%setup -q

%build
# genome-lib
cd genome-lib
rake package
cd ..

# genome-bootstrap
cd genome-bootstrap
rake package
cd ..

# genome-docs
#cd genome-docs
#make clean html html-single
#cd ..

# genome-dsl
cd genome-dsl
rake package
cd ..

# genome-release
cd genome-release
for file in `ls *.repo`; do
    ./munge-repofiles.sh $file %{?dist}
done
cd ..

# genome-respin
cd genome-respin
pod2man --section=1 --release="genome-respin %{version}" --center "Genome Respin using Revisor" docs/genome-respin.pod > docs/genome-respin.1
cd ..

# genome-sync
cd genome-sync
rake package
cd ..

# genome-server
cd genomed
rake package
cd ..

# genome-cloudhost
cd genome-cloudhost
rake package
cd ..

# genome-cloudmasterd
cd genome-cloudmasterd
rake package
cd ..

# genome-report
cd genome-report
rake package
cd ..

%install
rm -rf %{buildroot}

# genome
mkdir -p %{buildroot}/%{_sysconfdir}/genome
cp genome.conf.example %{buildroot}/%{_sysconfdir}/genome/genome.conf

# genome-lib
mkdir -p %{buildroot}%{gemdir} %{buildroot}/%{_datadir}/doc/genome-lib-%{version}/ 
gem install --local --install-dir %{buildroot}%{gemdir} --force --rdoc genome-lib/pkg/genome-lib-%{version}.gem
mv %{buildroot}/%{gemdir}/gems/genome-lib-%{version}/README %{buildroot}/%{_datadir}/doc/genome-lib-%{version}/

# genome-bootstrap
# there is no rdoc or ri documentation for genome-bootstrap (and no mandatory "lib" directory)
# forcefully skipping rdoc and ri installation
mkdir -p %{buildroot}%{gemdir} %{buildroot}/%{_sbindir}
gem install --local --install-dir %{buildroot}%{gemdir} --force --no-rdoc --no-ri genome-bootstrap/pkg/genome-bootstrap-%{version}.gem
cp %{buildroot}%{gemdir}/bin/* %{buildroot}/%{_sbindir}
rm -rf %{buildroot}%{gemdir}/bin
find %{buildroot}%{gemdir}/gems/genome-bootstrap-%{version}/bin -type f | xargs chmod a+x

# genome-bridge
install -Dpm 755 genome-bridge/genome-bridge %{buildroot}%{_sysconfdir}/init.d/genome-bridge

# genome-docs
#mkdir -p %{buildroot}/var/www/genome/docs
#mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
#cd genome-docs/
#cp -r tmp/* %{buildroot}/var/www/genome/docs
#cp docs.conf %{buildroot}%{_sysconfdir}/httpd/conf.d/genome-docs.conf
#cd ..

# genome-dsl
mkdir -p %{buildroot}/%{gemdir} %{buildroot}/%{_datadir}/doc/genome-dsl-%{version}/
gem install --local --install-dir %{buildroot}%{gemdir} --force --rdoc genome-dsl/pkg/genome-dsl-%{version}.gem
mv %{buildroot}/%{gemdir}/gems/genome-dsl-%{version}/README %{buildroot}/%{_datadir}/doc/genome-dsl-%{version}/

# genome-firstboot
mkdir -p %{buildroot}/%{_sysconfdir}/sysconfig %{buildroot}/%{_sysconfdir}/init.d %{buildroot}/%{_sbindir} %{buildroot}/%{_bindir}
cd genome-firstboot
install -pm 755 genome-firstboot.init %{buildroot}/%{_sysconfdir}/init.d/genome-firstboot
install -pm 755 genome-firstboot %{buildroot}/%{_sbindir}
install -pm 755 genome-puppetrun %{buildroot}/%{_bindir}
cd ..
echo "RUN_BOOTSTRAP=NO" > %{buildroot}/%{_sysconfdir}/sysconfig/genome-firstboot

# genome-func
mkdir -p %{buildroot}/%{_bindir} %{buildroot}/%{python_sitelib}/func/overlord
install -pm 755 genome-func/func-find-resources %{buildroot}/%{_bindir}
install -pm 644 genome-func/find_resources.py %{buildroot}/%{python_sitelib}/func/overlord

# genome-release
mkdir -p %{buildroot}/%{_sysconfdir}/pki/rpm-gpg %{buildroot}/%{_sysconfdir}/yum.repos.d
cd genome-release
install -Dpm 644 RPM-GPG-KEY-genome %{buildroot}/%{_sysconfdir}/pki/rpm-gpg/
install -dm 755 %{buildroot}/%{_sysconfdir}/yum.repos.d

%if 0%{?fedora} >= 8
install -pm 644 F-%{fedora}/genome.repo %{buildroot}/%{_sysconfdir}/yum.repos.d
#install -pm 644 F-%{fedora}/genome-testing.repo %{buildroot}/%{_sysconfdir}/yum.repos.d
#install -pm 644 F-%{fedora}/genome-devel.repo %{buildroot}/%{_sysconfdir}/yum.repos.d
%endif

%if 0%{?rhel} >= 5
install -pm 644 EL-%{rhel}/genome.repo %{buildroot}/%{_sysconfdir}/yum.repos.d
#install -pm 644 EL-%{rhel}/genome-testing.repo %{buildroot}/%{_sysconfdir}/yum.repos.d
#install -pm 644 EL-%{rhel}/genome-devel.repo %{buildroot}/%{_sysconfdir}/yum.repos.d
%endif

cd ..

# genome-replace-self
mkdir -p %{buildroot}/%{_bindir} %{buildroot}/%{_datadir}/genome-replace-self
install -pm 755 genome-replace-self/genome-replace-self %{buildroot}/%{_bindir}
install -pm 755 genome-replace-self/genome-replace-self.rb %{buildroot}/%{_datadir}/genome-replace-self

# genome-repo
mkdir -p %{buildroot}/%{_sysconfdir}/genome %{buildroot}/%{_sysconfdir}/cobbler %{buildroot}/var/lib/puppet/modules
mkdir -p %{buildroot}/%{_sysconfdir}/init.d
cd genome-repo
cp -r genome_module %{buildroot}/var/lib/puppet/modules/genomerepo
install -m 644 repo.yaml %{buildroot}/%{_sysconfdir}/genome
install -m 644 genome_module/files/machine_types.rb %{buildroot}/%{_sysconfdir}/genome
install -m 644 bootstrap.pp %{buildroot}/%{_sysconfdir}/genome
install -m 644 Genome.ks %{buildroot}/%{_sysconfdir}/cobbler
install -m 644 Cloud.ks %{buildroot}/%{_sysconfdir}/cobbler
install -m 644 CloudXen.ks %{buildroot}/%{_sysconfdir}/cobbler
install -m 644 Guest.ks %{buildroot}/%{_sysconfdir}/cobbler
install -m 644 VanillaGuest.ks %{buildroot}/%{_sysconfdir}/cobbler
install -m 755 genome-repo-bootstrap %{buildroot}/%{_sysconfdir}/init.d
cd ..

# genome-respin
mkdir -p %{buildroot}/%{_sysconfdir}/revisor
mkdir -p %{buildroot}/%{_mandir}/man1
cd genome-respin
cp -R genome.conf %{buildroot}/%{_sysconfdir}/revisor
cp -R conf.d %{buildroot}/%{_sysconfdir}/revisor
cp docs/*.? %{buildroot}/%{_mandir}/man1
cd ..

# genome-sync
mkdir -p %{buildroot}%{gemdir}
gem install --local --install-dir %{buildroot}%{gemdir} --force genome-sync/pkg/genome-sync-%{version}.gem
mkdir -p %{buildroot}/%{_bindir}
mv %{buildroot}%{gemdir}/bin/* %{buildroot}/%{_bindir}
rmdir %{buildroot}%{gemdir}/bin
find %{buildroot}%{gemdir}/gems/genome-sync-%{version}/bin -type f | xargs chmod a+x

# genome-server
mkdir -p %{buildroot}%{gemdir} %{buildroot}%{_sysconfdir}/init.d/ %{buildroot}%{_sysconfdir}/genomed
gem install --local --install-dir %{buildroot}%{gemdir} --force genomed/pkg/genomed-%{version}.gem
mkdir -p %{buildroot}/%{_bindir}
mv %{buildroot}%{gemdir}/bin/* %{buildroot}/%{_bindir}
cp genomed/extra/genomed.redhat %{buildroot}%{_sysconfdir}/init.d/genomed
rmdir %{buildroot}%{gemdir}/bin
find %{buildroot}%{gemdir}/gems/genomed-%{version}/bin -type f | xargs chmod a+x
# Remove init scripts and other extras from the location the gem installs them;
# they're already in the right locations as well
rm -rf %{buildroot}%{gemdir}/gems/genomed-%{version}/extra

# genome-styling
mkdir -p %{buildroot}/%{stylingdir}
mkdir -p %{buildroot}/%{webscriptsdir}
cp genome-styling/genome-mainbgcurve.png %{buildroot}%{stylingdir}
cp genome-styling/genome-mainbg.png %{buildroot}%{stylingdir}
cp genome-styling/glogo.gif %{buildroot}%{stylingdir}
cp genome-styling/styles.css %{buildroot}%{stylingdir}
cp genome-styling/pause-32x32.png %{buildroot}%{stylingdir}
cp genome-styling/play-32x32.png %{buildroot}%{stylingdir}
cp genome-styling/stop-32x32.png %{buildroot}%{stylingdir}
cp genome-styling/help-16x16.png %{buildroot}%{stylingdir}
cp genome-styling/help-32x32.png %{buildroot}%{stylingdir}
cp genome-styling/jquery-1.2.6.js %{buildroot}%{webscriptsdir}
cp genome-styling/jquery-ui-minimized-1.6rc2.js %{buildroot}%{webscriptsdir}

# Put in the apache rules
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
cp genomed/extra/genomed.apache %{buildroot}%{_sysconfdir}/httpd/conf.d/genomed.conf
cp genome-styling/extra/genome-styling.apache %{buildroot}%{_sysconfdir}/httpd/conf.d/genome-styling.conf

# genome-cloudhost
mkdir -p %{buildroot}%{gemdir} %{buildroot}%{_sysconfdir}/init.d %{buildroot}%{_sysconfdir}/cloudhost
gem install --local --install-dir %{buildroot}%{gemdir} \
    --force --rdoc genome-cloudhost/pkg/cloudhost-%{version}.gem
mkdir -p %{buildroot}/%{_bindir}
mv %{buildroot}%{gemdir}/bin/* %{buildroot}/%{_bindir}
cp genome-cloudhost/extra/cloudhost.init %{buildroot}%{_sysconfdir}/init.d/cloudhost
rmdir %{buildroot}%{gemdir}/bin
find %{buildroot}%{gemdir}/gems/cloudhost-%{version}/bin -type f | xargs chmod a+x
# Remove init scripts and other extras from the location the gem installs them;
# they're already in the right locations as well
rm -rf %{buildroot}%{gemdir}/gems/cloudhost-%{version}/extra

# genome-cloudhost-httpd
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
cp genome-cloudhost/extra/cloudhost.apache %{buildroot}%{_sysconfdir}/httpd/conf.d/cloudhost.conf

# genome-cloudhost-httpd-redirect
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
cp genome-cloudhost/extra/cloudhost-redirect.apache %{buildroot}%{_sysconfdir}/httpd/conf.d/cloudhost-redirect.conf

# genome-cloudmasterd
mkdir -p %{buildroot}%{gemdir} %{buildroot}%{_sysconfdir}/init.d %{buildroot}%{_sysconfdir}/cloudmasterd
gem install --local --install-dir %{buildroot}%{gemdir} \
    --force --rdoc genome-cloudmasterd/pkg/cloudmasterd-%{version}.gem
mkdir -p %{buildroot}/%{_bindir}
mv %{buildroot}%{gemdir}/bin/* %{buildroot}/%{_bindir}
cp genome-cloudmasterd/extra/cloudmasterd.init %{buildroot}%{_sysconfdir}/init.d/cloudmasterd
rmdir %{buildroot}%{gemdir}/bin
find %{buildroot}%{gemdir}/gems/cloudmasterd-%{version}/bin -type f | xargs chmod a+x
# Remove init scripts and other extras from the location the gem installs them;
# they're already in the right locations as well
rm -rf %{buildroot}%{gemdir}/gems/cloudmasterd-%{version}/extra

# genome-cloudmasterd-httpd
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
cp genome-cloudmasterd/extra/cloudmasterd.apache %{buildroot}%{_sysconfdir}/httpd/conf.d/cloudmasterd.conf

# genome-cloudmasterd-httpd-redirect
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
cp genome-cloudmasterd/extra/cloudmasterd-redirect.apache %{buildroot}%{_sysconfdir}/httpd/conf.d/cloudmasterd-redirect.conf

# genome-report
mkdir -p %{buildroot}%{gemdir}
gem install --local --install-dir %{buildroot}%{gemdir} --force genome-report/pkg/genome-report-%{version}.gem
mkdir -p %{buildroot}/%{_bindir}
mv %{buildroot}%{gemdir}/bin/* %{buildroot}/%{_bindir}
rmdir %{buildroot}%{gemdir}/bin
find %{buildroot}%{gemdir}/gems/genome-report-%{version}/bin -type f | xargs chmod a+x

%clean
rm -rf %{buildroot}

##
## Genome Bridge Post and Pre
##
%preun bridge
/sbin/chkconfig --del genome-bridge

%post bridge
/sbin/chkconfig --add genome-bridge

##
## Genome Firstboot Post and Pre
##
%preun firstboot
/sbin/chkconfig --del genome-firstboot
if [ "$1" = "0" ] ; then # last uninstall
    /sbin/chkconfig genome-firstboot off
fi

%post firstboot
/sbin/chkconfig --add genome-firstboot
if [ "$1" = "1" ] ; then  # first install
  /sbin/chkconfig genome-firstboot on
fi

##
## Genome Repo Bootstrap Post and Pre
##
%preun repo
/sbin/chkconfig --del genome-repo-bootstrap
if [ "$1" = "0" ] ; then # last uninstall
    /sbin/chkconfig genome-repo-bootstrap off
fi

%post repo
/sbin/chkconfig --add genome-repo-bootstrap
if [ "$1" = "1" ] ; then  # first install
  /sbin/chkconfig genome-repo-bootstrap on
fi

##
## Genome Server Post and Pre
##
%preun server
/sbin/chkconfig --del genomed
if [ "$1" = "0" ] ; then # last uninstall
    /sbin/chkconfig genomed off
fi

%post server
/sbin/chkconfig --add genomed
if [ "$1" = "1" ] ; then  # first install
  /sbin/chkconfig genomed on
fi


##
## Genome Cloudmasterd Post and Pre
##
%preun cloudmasterd
if [ $1 = 0 ]; then
        /sbin/service cloudmasterd stop > /dev/null 2>&1
        /sbin/chkconfig --del cloudmasterd
fi

%post cloudmasterd
/sbin/chkconfig --add cloudmasterd


%files
%doc COPYING
%defattr(-, root, root)
%dir %{_sysconfdir}/genome
%config(noreplace) %{_sysconfdir}/genome/genome.conf

%files lib
%defattr(-, root, root)
%doc %{_datadir}/doc/genome-lib-%{version}/README
%{gemdir}/gems/genome-lib-%{version}/
%doc %{gemdir}/doc/genome-lib-%{version}
%{gemdir}/cache/genome-lib-%{version}.gem
%{gemdir}/specifications/genome-lib-%{version}.gemspec

%files bootstrap
%defattr(-, root, root)
%doc COPYING
%{_sbindir}/genome-bootstrap
%{gemdir}/gems/genome-bootstrap-%{version}/
%{gemdir}/cache/genome-bootstrap-%{version}.gem
%{gemdir}/specifications/genome-bootstrap-%{version}.gemspec

%files bridge
%defattr(-,root,root,-)
%doc COPYING
%{_sysconfdir}/init.d/genome-bridge

#%files docs
#%defattr(-,root,root,-)
#%doc COPYING
#%config(noreplace) %{_sysconfdir}/httpd/conf.d/genome-docs.conf
#/var/www/genome/docs

%files dsl
%defattr(-, root, root)
%doc %{_datadir}/doc/genome-dsl-%{version}/README
%{gemdir}/gems/genome-dsl-%{version}/
%doc %{gemdir}/doc/genome-dsl-%{version}
%{gemdir}/cache/genome-dsl-%{version}.gem
%{gemdir}/specifications/genome-dsl-%{version}.gemspec

%files firstboot
%defattr(-,root,root,-)
%doc COPYING
%config(noreplace) /%{_sysconfdir}/sysconfig/genome-firstboot
%defattr(755,root,root,-)
/%{_sysconfdir}/init.d/genome-firstboot
/%{_sbindir}/genome-firstboot
/%{_bindir}/genome-puppetrun

%files func
%defattr(-,root,root,-)
%doc COPYING
%{_bindir}/func-find-resources
/%{python_sitelib}/func/overlord/find_resources.py*

%files release
%defattr(-,root,root,-)
%doc COPYING
%{_sysconfdir}/pki/rpm-gpg/*
%config(noreplace) %{_sysconfdir}/yum.repos.d/*

%files replace-self
%defattr(-,root,root,-)
%doc COPYING
%{_bindir}/genome-replace-self
%{_datadir}/genome-replace-self/genome-replace-self.rb

%files repo
%defattr(-,root,root,-)
%doc COPYING
/%{_sysconfdir}/init.d/genome-repo-bootstrap
/var/lib/puppet/modules/genomerepo
%config(noreplace) /%{_sysconfdir}/genome/bootstrap.pp
%config(noreplace) /%{_sysconfdir}/cobbler/Genome.ks
%config(noreplace) /%{_sysconfdir}/cobbler/Cloud.ks
%config(noreplace) /%{_sysconfdir}/cobbler/CloudXen.ks
%config(noreplace) /%{_sysconfdir}/cobbler/Guest.ks
%config(noreplace) /%{_sysconfdir}/cobbler/VanillaGuest.ks
%config(noreplace) /%{_sysconfdir}/genome/repo.yaml
%config(noreplace) /%{_sysconfdir}/genome/machine_types.rb

%files respin
%defattr(-,root,root,-)
%doc COPYING
%{_mandir}/man1/genome-respin.*.gz
%config(noreplace) /%{_sysconfdir}/revisor/genome.conf
%config(noreplace) /%{_sysconfdir}/revisor/conf.d/genome-ks.cfg
%config(noreplace) /%{_sysconfdir}/revisor/conf.d/cloud-ks.cfg
%config(noreplace) /%{_sysconfdir}/revisor/conf.d/combo-ks.cfg
%config(noreplace) /%{_sysconfdir}/revisor/conf.d/genome-f9-i386.conf

%files styling
%defattr(-, root, root, -)
%doc COPYING
%config(noreplace) %{_sysconfdir}/httpd/conf.d/genome-styling.conf
%{stylingdir}
%{stylingdir}/genome-mainbgcurve.png
%{stylingdir}/genome-mainbg.png
%{stylingdir}/glogo.gif
%{stylingdir}/styles.css
%{stylingdir}/pause-32x32.png
%{stylingdir}/play-32x32.png
%{stylingdir}/stop-32x32.png
%{stylingdir}/help-16x16.png
%{stylingdir}/help-32x32.png
%{webscriptsdir}/jquery-1.2.6.js
%{webscriptsdir}/jquery-ui-minimized-1.6rc2.js

%files sync
%defattr(-, root, root, -)
%doc COPYING
%{_bindir}/genome-sync
%{gemdir}/gems/genome-sync-%{version}/
%{gemdir}/cache/genome-sync-%{version}.gem
%{gemdir}/specifications/genome-sync-%{version}.gemspec

%files server
%defattr(-, root, root, -)
%doc COPYING
%{_bindir}/genomed
%{gemdir}/gems/genomed-%{version}/
%doc %{gemdir}/doc/genomed-%{version}
%{gemdir}/cache/genomed-%{version}.gem
%{gemdir}/specifications/genomed-%{version}.gemspec
%config(noreplace) %{_sysconfdir}/httpd/conf.d/genomed.conf

%defattr(755, root, root, -)
%{_sysconfdir}/init.d/genomed

%files cloudhost
%{_bindir}/cloudhost
%{gemdir}/gems/cloudhost-%{version}/
%doc %{gemdir}/doc/cloudhost-%{version}
%doc %{gemdir}/gems/cloudhost-%{version}/LICENSE
%doc %{gemdir}/gems/cloudhost-%{version}/README
%{gemdir}/cache/cloudhost-%{version}.gem
%{gemdir}/specifications/cloudhost-%{version}.gemspec

%defattr(755, root, root, -)
%{_sysconfdir}/init.d/cloudhost

%files cloudhost-httpd
%config(noreplace) %{_sysconfdir}/httpd/conf.d/cloudhost.conf

%files cloudhost-httpd-redirect
%config(noreplace) %{_sysconfdir}/httpd/conf.d/cloudhost-redirect.conf

%files cloudmasterd
%{_bindir}/cloudmasterd
%{gemdir}/gems/cloudmasterd-%{version}/
%doc %{gemdir}/doc/cloudmasterd-%{version}
%doc %{gemdir}/gems/cloudmasterd-%{version}/LICENSE
%doc %{gemdir}/gems/cloudmasterd-%{version}/README
%{gemdir}/cache/cloudmasterd-%{version}.gem
%{gemdir}/specifications/cloudmasterd-%{version}.gemspec

%defattr(755, root, root, -)
%{_sysconfdir}/init.d/cloudmasterd

%files cloudmasterd-httpd
%config(noreplace) %{_sysconfdir}/httpd/conf.d/cloudmasterd.conf

%files cloudmasterd-httpd-redirect
%config(noreplace) %{_sysconfdir}/httpd/conf.d/cloudmasterd-redirect.conf

%files report
%defattr(-, root, root, -)
%doc COPYING
%{_bindir}/genome-report
%{gemdir}/gems/genome-report-%{version}/
%{gemdir}/cache/genome-report-%{version}.gem
%{gemdir}/specifications/genome-report-%{version}.gemspec


%changelog
* Tue Oct 14 2008 Brenton Leanhardt <bleanhar@redhat.com> 1.4.0-30
- https://fedorahosted.org/genome/ticket/114
- docs update

* Mon Oct 13 2008 Brenton Leanhardt <bleanhar@redhat.com> 1.4.0-22
- https://fedorahosted.org/genome/ticket/109
- Adding locking for Cloud threads

* Tue Oct 7 2008 Brenton Leanhardt <bleanhar@redhat.com> 1.4.0-5
- Removed picnic dependency for cloudmasterd
- Removed picnic dependency for cloudhost
- Removed picnic dependency for genomed

* Thu Oct 02 2008 Greg Blomquist <gblomqui@redhat.com> 1.4.0-2
- Added jquery script to genome-styling

* Tue Sep 30 2008 Greg Blomquist <gblomqui@redhat.com> 1.4.0-1
- Added genome-cloudhost
- Added genome-report

* Fri Sep 25 2008 Brenton Leanhardt <bleanhar@redhat.com> 1.3.3-1
- genome-replace-self uses uuid's instead of mac addresses

* Thu Sep 25 2008 Jeroen van Meeuwen <kanarip@fedoraproject.org> - 1.3.1-3
- Fix packaging errors

* Fri Sep 5 2008 Brenton Leanhardt <bleanhar@redhat.com> 1.1.2-1
- Styling fixes

* Thu Sep 4 2008 Brenton Leanhardt <bleanhar@redhat.com> 1.1.1-4
- Added genome-cloudmasterd and related packages
- Added proper obsoletes

* Wed Sep 3 2008 Brenton Leanhardt <bleanhar@redhat.com> 1.1.1-2
- Fixed genome-server Requires

* Wed Sep 3 2008 Brenton Leanhardt <bleanhar@redhat.com> 1.1.1-1
- Bug fixes for genome-sync and genome-repo

* Tue Sep 2 2008 Brenton Leanhardt <bleanhar@redhat.com> 1.1.0-1
- Added genome-server package

* Mon Jul 21 2008 Jeroen van Meeuwen <kanarip@fedoraproject.org> - 1.0.0-1
- Some cleaning up for package review

* Tue Jun 24 2008  <mhicks@redhat.com> - 1.0.0-1
- Initial package
